ompi/mca/btl/sm/btl_sm.h File Reference.TH "ompi/mca/btl/sm/btl_sm.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/btl/sm/btl_sm.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include <stdlib.h>\fP
.br
\fC#include <sys/types.h>\fP
.br
\fC#include <sys/socket.h>\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br
\fC#include 'class/ompi_bitmap.h'\fP
.br
\fC#include 'class/ompi_fifo.h'\fP
.br
\fC#include 'opal/event/event.h'\fP
.br
\fC#include 'mca/pml/pml.h'\fP
.br
\fC#include 'mca/btl/btl.h'\fP
.br
\fC#include 'mca/btl/base/base.h'\fP
.br
\fC#include 'mca/mpool/mpool.h'\fP
.br
\fC#include 'mca/common/sm/common_sm_mmap.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBSM_CONNECTED\fP   1"
.br
.ti -1c
.RI "#define \fBSM_CONNECTED_SAME_BASE_ADDR\fP   2"
.br
.ti -1c
.RI "#define \fBSM_CONNECTED_DIFFERENT_BASE_ADDR\fP   3"
.br
.ti -1c
.RI "#define \fBMCA_BTL_SM_SIGNAL_PEER\fP(peer)"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef mca_btl_sm_module_resource_t \fBmca_btl_sm_module_resource_t\fP"
.br
.ti -1c
.RI "typedef mca_btl_base_recv_reg_t \fBmca_btl_sm_recv_reg_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_btl_sm_component_t\fP \fBmca_btl_sm_component_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_btl_sm_t\fP \fBmca_btl_sm_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_btl_sm_component_open\fP (void)"
.br
.RI "\fIRegister shared memory module parameters with the MCA framework. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_component_close\fP (void)"
.br
.RI "\fIAny final cleanup before being unloaded. \fP"
.ti -1c
.RI "\fBmca_btl_base_module_t\fP ** \fBmca_btl_sm_component_init\fP (int *num_btls, bool enable_progress_threads, bool enable_mpi_threads)"
.br
.RI "\fISM module initialization. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_component_progress\fP (void)"
.br
.RI "\fIshared memory component progress. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_finalize\fP (struct \fBmca_btl_base_module_t\fP *btl)"
.br
.RI "\fICleanup any resources held by the BTL. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_add_procs\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **peers, struct ompi_bitmap_t *reachability)"
.br
.RI "\fIPML->BTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_add_procs_same_base_addr\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **peers, ompi_bitmap_t *reachability)"
.br
.RI "\fIPML->BTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_del_procs\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **peers)"
.br
.RI "\fIPML->BTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_register\fP (struct \fBmca_btl_base_module_t\fP *btl, mca_btl_base_tag_t tag, \fBmca_btl_base_module_recv_cb_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIRegister a callback function that is called on receipt of a fragment. \fP"
.ti -1c
.RI "\fBmca_btl_base_descriptor_t\fP * \fBmca_btl_sm_alloc\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t size)"
.br
.RI "\fIAllocate a segment. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_free\fP (struct \fBmca_btl_base_module_t\fP *btl, \fBmca_btl_base_descriptor_t\fP *segment)"
.br
.RI "\fIReturn a segment allocated by this BTL. \fP"
.ti -1c
.RI "\fBmca_btl_base_descriptor_t\fP * \fBmca_btl_sm_prepare_src\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, mca_mpool_base_registration_t *registration, struct ompi_convertor_t *convertor, size_t reserve, size_t *size)"
.br
.RI "\fIPack data. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_send\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, struct \fBmca_btl_base_descriptor_t\fP *descriptor, mca_btl_base_tag_t tag)"
.br
.RI "\fIInitiate a send to the peer. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "mca_btl_sm_module_resource_t \fBmca_btl_sm_module_resource\fP"
.br
.ti -1c
.RI "\fBmca_btl_sm_component_t\fP \fBmca_btl_sm_component\fP"
.br
.ti -1c
.RI "\fBmca_btl_sm_t\fP \fBmca_btl_sm\fP [2]"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Function Documentation"
.PP 
.SS "int mca_btl_sm_add_procs (struct \fBmca_btl_base_module_t\fP * btl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_btl_base_endpoint_t\fP ** peers, struct ompi_bitmap_t * reachability)"
.PP
PML->BTL notification of change in the process list. 
.PP
PML->BTL Notification that a receive fragment has been matched. Called for message that is send from process with the virtual address of the shared memory segment being different than that of the receiver.
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) 
.br
\fIproc\fP (IN) 
.br
\fIpeer\fP (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "int mca_btl_sm_add_procs_same_base_addr (struct \fBmca_btl_base_module_t\fP * btl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_btl_base_endpoint_t\fP ** peers, ompi_bitmap_t * reachability)"
.PP
PML->BTL notification of change in the process list. 
.PP
PML->BTL Notification that a receive fragment has been matched. Called for message that is send from process with the virtual address of the shared memory segment being the same as that of the receiver.
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) 
.br
\fIproc\fP (IN) 
.br
\fIpeer\fP (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "\fBmca_btl_base_descriptor_t\fP* mca_btl_sm_alloc (struct \fBmca_btl_base_module_t\fP * btl, size_t size)"
.PP
Allocate a segment. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIsize\fP (IN) Request segment size. 
.RE
.PP

.SS "\fBmca_btl_base_module_t\fP** mca_btl_sm_component_init (int * num_btls, bool enable_progress_threads, bool enable_mpi_threads)"
.PP
SM module initialization. 
.PP
\fBParameters:\fP
.RS 4
\fInum_btls\fP (OUT) Number of BTLs returned in BTL array. 
.br
\fIenable_progress_threads\fP (IN) Flag indicating whether BTL is allowed to have progress threads 
.br
\fIenable_mpi_threads\fP (IN) Flag indicating whether BTL must support multilple simultaneous invocations from different threads 
.RE
.PP

.SS "int mca_btl_sm_del_procs (struct \fBmca_btl_base_module_t\fP * btl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_btl_base_endpoint_t\fP ** peers)"
.PP
PML->BTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL instance 
.br
\fIproc\fP (IN) Peer process 
.br
\fIpeer\fP (IN) Peer addressing information. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful 
.RE
.PP

.SS "int mca_btl_sm_finalize (struct \fBmca_btl_base_module_t\fP * btl)"
.PP
Cleanup any resources held by the BTL. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module.
.RE
.PP
Prior to unloading a BTL module, the MCA framework will call the BTL finalize method of the module. Any resources held by the BTL should be released and if required the memory corresponding to the BTL module freed. 
.SS "int mca_btl_sm_free (struct \fBmca_btl_base_module_t\fP * btl, \fBmca_btl_base_descriptor_t\fP * des)"
.PP
Return a segment allocated by this BTL. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIsegment\fP (IN) Allocated segment. 
.RE
.PP

.SS "struct \fBmca_btl_base_descriptor_t\fP* mca_btl_sm_prepare_src (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * endpoint, mca_mpool_base_registration_t * registration, struct ompi_convertor_t * convertor, size_t reserve, size_t * size)"
.PP
Pack data. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.RE
.PP

.SS "int mca_btl_sm_register (struct \fBmca_btl_base_module_t\fP * btl, mca_btl_base_tag_t tag, \fBmca_btl_base_module_recv_cb_fn_t\fP cbfunc, void * cbdata)"
.PP
Register a callback function that is called on receipt of a fragment. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful
.RE
.PP
When the process list changes, the PML notifies the BTL of the change, to provide the opportunity to cleanup or release any resources associated with the peer. 
.SS "int mca_btl_sm_send (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * endpoint, struct \fBmca_btl_base_descriptor_t\fP * descriptor, mca_btl_base_tag_t tag)"
.PP
Initiate a send to the peer. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIpeer\fP (IN) BTL peer addressing 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
